<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:log="http://www.xoev.de/de/xgenerator/framework/1/log" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xoev="http://www.xoev.de/de/xoev-profil/1_7_1" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" xmlns:svg="http://www.w3.org/2000/svg" xmlns:xinclude="http://www.w3.org/2001/XInclude" xmlns:gc="http://docs.oasis-open.org/codelist/ns/genericode/1.0/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xoev-cl-3="http://xoev.de/schemata/genericode/3" version="2.0" exclude-result-prefixes="xsl xmi xgen xoev uml xd log xs svg xinclude">

    <xsl:template match="/" mode="xoev:default">
        <xsl:apply-templates select="$uml:root-model/packagedElement[@name='Codelisten']/packagedElement[@name='eigene Codelisten']/descendant-or-self::packagedElement[uml:is-Class(.) and xoev:xoevVersionCodeliste(.) and not(xoev:xsdDraft(.))]" mode="xoev:genericode-document"/>
    </xsl:template>

    <xsl:template match="packagedElement" mode="xoev:genericode-document">
        <xsl:variable name="codeliste" select="xoev:dependencies-by-client(.)/uml:resolve-supplier(.)"/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="xs:anyURI(concat(replace($codeliste/xoev:xoevCodeliste(.)/@kennung, ':', '-'), '_', xoev:xoevVersionCodeliste(.)/@version, '.xml'))"/>
            <xsl:with-param name="content">
                <xsl:variable name="codelistenversion" select="."/>
                <xsl:variable name="code-spalte" select="(ownedAttribute[xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'], ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true'])[1]"/>
                <gc:CodeList>
                    <Annotation>
                        <Description>
                            <xsl:for-each select="$codeliste/xoev:xoevCodeliste(.)/@nameKurz[. != '']">
                                <xoev-cl-3:nameKurz>
                                    <xsl:value-of select="."/>
                                </xoev-cl-3:nameKurz>
                            </xsl:for-each>
                            <xsl:for-each select="$codeliste/xoev:xoevCodeliste(.)/@beschreibung[. != '']">
                                <xoev-cl-3:beschreibung-codeliste>
                                    <xsl:value-of select="xoev:clean-text(.)"/>
                                </xoev-cl-3:beschreibung-codeliste>
                            </xsl:for-each>
                            <xsl:for-each select="$codeliste/xoev:xoevCodeliste(.)/@herausgebernameKurz[. != '']">
                                <xoev-cl-3:herausgebernameKurz>
                                    <xsl:value-of select="."/>
                                </xoev-cl-3:herausgebernameKurz>
                            </xsl:for-each>
                            <xsl:for-each select="xoev:xoevVersionCodeliste(.)/@beschreibung[. != '']">
                                <xoev-cl-3:beschreibung-versionCodeliste>
                                    <xsl:value-of select="xoev:clean-text(.)"/>
                                </xoev-cl-3:beschreibung-versionCodeliste>
                            </xsl:for-each>
                            <xsl:for-each select="xoev:xoevVersionCodeliste(.)/@datumGueltigkeitAb[. != '']">
                                <xoev-cl-3:datumGueltigkeitAb>
                                    <xsl:value-of select="."/>
                                </xoev-cl-3:datumGueltigkeitAb>
                            </xsl:for-each>
                            <xsl:for-each select="xoev:xoevVersionCodeliste(.)/@versionCodelistenHandbuch[. != '']">
                                <xoev-cl-3:versionCodelistenHandbuch>
                                    <xsl:value-of select="."/>
                                </xoev-cl-3:versionCodelistenHandbuch>
                            </xsl:for-each>
                            <xsl:for-each select="xoev:xoevVersionCodeliste(.)/@aenderungZurVorversion[. != '']">
                                <xoev-cl-3:aenderungZurVorversion>
                                    <xsl:value-of select="."/>
                                </xoev-cl-3:aenderungZurVorversion>
                            </xsl:for-each>
                        </Description>
                    </Annotation>
                    <Identification>
                        <ShortName>
                            <xsl:value-of select="$codeliste/xoev:xoevCodeliste(.)/@nameTechnisch"/>
                        </ShortName>
                        <LongName>
                            <xsl:value-of select="$codeliste/xoev:xoevCodeliste(.)/@nameLang"/>
                        </LongName>
                        <Version>
                            <xsl:value-of select="xoev:xoevVersionCodeliste(.)/@version"/>
                        </Version>
                        <CanonicalUri>
                            <xsl:value-of select="$codeliste/xoev:xoevCodeliste(.)/@kennung"/>
                        </CanonicalUri>
                        <CanonicalVersionUri>
                            <xsl:value-of select="concat($codeliste/xoev:xoevCodeliste(.)/@kennung, '_', xoev:xoevVersionCodeliste(.)/@version)"/>
                        </CanonicalVersionUri>
                        <xsl:for-each select="xoev:xoevVersionCodeliste(.)/@bezugsort">
                            <AlternateFormatLocationUri>
                                <xsl:value-of select="."/>
                            </AlternateFormatLocationUri>
                        </xsl:for-each>
                        <Agency>
                            <LongName>
                                <xsl:value-of select="$codeliste/xoev:xoevCodeliste(.)/@herausgebernameLang"/>
                            </LongName>
                        </Agency>
                    </Identification>
                    <ColumnSet>
                        <xsl:for-each select="ownedAttribute">
                            <Column Id="{@name}" Use="{(xoev:xoevCodelistenspalte(.)/@verwendung,'required')[1]}">
                                <ShortName>
                                    <xsl:value-of select="@name"/>
                                </ShortName>
                                <xsl:for-each select="xoev:xoevCodelistenspalte(.)/@spaltennameLang">
                                    <LongName>
                                        <xsl:value-of select="."/>
                                    </LongName>
                                </xsl:for-each>
                                <Data Type="{(xoev:xoevCodelistenspalte(.)/@datentyp,'string')[1]}"/>
                            </Column>
                        </xsl:for-each>
                        <xsl:for-each select="ownedAttribute[xoev:xoevCodelistenspalte(.)/@codeSpalte = 'true']">
                            <Key Id="{concat(@name,'Key')}">
                                <xsl:if test="xoev:xoevCodelistenspalte(.)/@empfohleneCodeSpalte = 'true'">
                                    <Annotation>
                                        <AppInfo>
                                            <xoev-cl-3:empfohleneCodeSpalte/>
                                        </AppInfo>
                                    </Annotation>
                                </xsl:if>
                                <ShortName>
                                    <xsl:value-of select="concat(@name, 'Key')"/>
                                </ShortName>
                                <ColumnRef Ref="{@name}"/>
                            </Key>
                        </xsl:for-each>
                    </ColumnSet>
                    <SimpleCodeList>
                        <xsl:for-each select="$uml:root-model/packagedElement[@name='Codelisten']/packagedElement[@name='eigene Codelisten']/descendant::packagedElement[uml:is-InstanceSpecification(.) and @classifier = current()/@xmi:id and not(xoev:xoevCodelisteneintragDeprecated(.))]">
                            <xsl:sort select="slot[uml:resolve-definingFeature(.)/@xmi:id = $code-spalte/@xmi:id]/value/@value/normalize-space(.)"/>
                            <xsl:variable name="codelisteneintrag" select="."/>
                            <Row>
                                <xsl:for-each select="$code-spalte, $codelistenversion/ownedAttribute[not(@xmi:id = $code-spalte/@xmi:id)]">
                                    <Value ColumnRef="{@name}">
                                        <SimpleValue>
                                            <xsl:value-of select="$codelisteneintrag/slot[uml:resolve-definingFeature(.)/@xmi:id = current()/@xmi:id]/value/@value/normalize-space(.)"/>
                                        </SimpleValue>
                                    </Value>
                                </xsl:for-each>
                            </Row>
                        </xsl:for-each>
                    </SimpleCodeList>
                </gc:CodeList>
            </xsl:with-param>
        </xsl:call-template>

    </xsl:template>
























</xsl:stylesheet>
